/*
 * Licensed Materials - Property of IBM
 *
 * com.ibm.etools.c
 *
 *  Copyright IBM Corporation 2004. All Rights Reserved. 
 *
 * Note to U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */
package com.ibm.etools.c.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

import com.ibm.etools.c.CClassifier;
import com.ibm.etools.c.CDerivableType;
import com.ibm.etools.c.CPackage;
import com.ibm.etools.c.CStructureContents;
import com.ibm.etools.c.CStructured;
import com.ibm.etools.tdlang.impl.TDLangComposedTypeImpl;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Structured</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>
 * {@link com.ibm.etools.c.impl.CStructuredImpl#getContainer <em>Container</em>}
 * </li>
 * <li>
 * {@link com.ibm.etools.c.impl.CStructuredImpl#getContains <em>Contains</em>}
 * </li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public abstract class CStructuredImpl extends TDLangComposedTypeImpl implements CStructured {
    /**
     * The cached value of the '{@link #getContains() <em>Contains</em>}'
     * containment reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @see #getContains()
     * @generated @ordered
     */
    protected EList contains = null;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected CStructuredImpl() {
        super();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected EClass eStaticClass() {
        return CPackage.eINSTANCE.getCStructured();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public CStructured getContainer() {
        if (eContainerFeatureID != CPackage.CSTRUCTURED__CONTAINER)
            return null;
        return (CStructured) eContainer;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void setContainer(CStructured newContainer) {
        if (newContainer != eContainer || (eContainerFeatureID != CPackage.CSTRUCTURED__CONTAINER && newContainer != null)) {
            if (EcoreUtil.isAncestor(this, newContainer))
                throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
            NotificationChain msgs = null;
            if (eContainer != null)
                msgs = eBasicRemoveFromContainer(msgs);
            if (newContainer != null)
                msgs = ((InternalEObject) newContainer).eInverseAdd(this, CPackage.CSTRUCTURED__CONTAINS, CStructured.class, msgs);
            msgs = eBasicSetContainer((InternalEObject) newContainer, CPackage.CSTRUCTURED__CONTAINER, msgs);
            if (msgs != null)
                msgs.dispatch();
        } else if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, CPackage.CSTRUCTURED__CONTAINER, newContainer, newContainer));
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public EList getContains() {
        if (contains == null) {
            contains = new EObjectContainmentWithInverseEList(CStructureContents.class, this, CPackage.CSTRUCTURED__CONTAINS, CPackage.CSTRUCTURE_CONTENTS__CONTAINER);
        }
        return contains;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
        if (featureID >= 0) {
            switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
            case CPackage.CSTRUCTURED__TD_LANG_TYPED_ELEMENT:
                return ((InternalEList) getTdLangTypedElement()).basicAdd(otherEnd, msgs);
            case CPackage.CSTRUCTURED__CONTAINER:
                if (eContainer != null)
                    msgs = eBasicRemoveFromContainer(msgs);
                return eBasicSetContainer(otherEnd, CPackage.CSTRUCTURED__CONTAINER, msgs);
            case CPackage.CSTRUCTURED__CONTAINS:
                return ((InternalEList) getContains()).basicAdd(otherEnd, msgs);
            default:
                return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
            }
        }
        if (eContainer != null)
            msgs = eBasicRemoveFromContainer(msgs);
        return eBasicSetContainer(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
        if (featureID >= 0) {
            switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
            case CPackage.CSTRUCTURED__TD_LANG_TYPED_ELEMENT:
                return ((InternalEList) getTdLangTypedElement()).basicRemove(otherEnd, msgs);
            case CPackage.CSTRUCTURED__TD_LANG_ELEMENT:
                return ((InternalEList) getTdLangElement()).basicRemove(otherEnd, msgs);
            case CPackage.CSTRUCTURED__CONTAINER:
                return eBasicSetContainer(null, CPackage.CSTRUCTURED__CONTAINER, msgs);
            case CPackage.CSTRUCTURED__CONTAINS:
                return ((InternalEList) getContains()).basicRemove(otherEnd, msgs);
            default:
                return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
            }
        }
        return eBasicSetContainer(null, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain eBasicRemoveFromContainer(NotificationChain msgs) {
        if (eContainerFeatureID >= 0) {
            switch (eContainerFeatureID) {
            case CPackage.CSTRUCTURED__CONTAINER:
                return ((InternalEObject) eContainer).eInverseRemove(this, CPackage.CSTRUCTURED__CONTAINS, CStructured.class, msgs);
            default:
                return eDynamicBasicRemoveFromContainer(msgs);
            }
        }
        return ((InternalEObject) eContainer).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - eContainerFeatureID, null, msgs);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public Object eGet(EStructuralFeature eFeature, boolean resolve) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case CPackage.CSTRUCTURED__NAME:
            return getName();
        case CPackage.CSTRUCTURED__TD_LANG_TYPED_ELEMENT:
            return getTdLangTypedElement();
        case CPackage.CSTRUCTURED__TD_LANG_ELEMENT:
            return getTdLangElement();
        case CPackage.CSTRUCTURED__CONTAINER:
            return getContainer();
        case CPackage.CSTRUCTURED__CONTAINS:
            return getContains();
        }
        return eDynamicGet(eFeature, resolve);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void eSet(EStructuralFeature eFeature, Object newValue) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case CPackage.CSTRUCTURED__NAME:
            setName((String) newValue);
            return;
        case CPackage.CSTRUCTURED__TD_LANG_TYPED_ELEMENT:
            getTdLangTypedElement().clear();
            getTdLangTypedElement().addAll((Collection) newValue);
            return;
        case CPackage.CSTRUCTURED__TD_LANG_ELEMENT:
            getTdLangElement().clear();
            getTdLangElement().addAll((Collection) newValue);
            return;
        case CPackage.CSTRUCTURED__CONTAINER:
            setContainer((CStructured) newValue);
            return;
        case CPackage.CSTRUCTURED__CONTAINS:
            getContains().clear();
            getContains().addAll((Collection) newValue);
            return;
        }
        eDynamicSet(eFeature, newValue);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public void eUnset(EStructuralFeature eFeature) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case CPackage.CSTRUCTURED__NAME:
            unsetName();
            return;
        case CPackage.CSTRUCTURED__TD_LANG_TYPED_ELEMENT:
            getTdLangTypedElement().clear();
            return;
        case CPackage.CSTRUCTURED__TD_LANG_ELEMENT:
            getTdLangElement().clear();
            return;
        case CPackage.CSTRUCTURED__CONTAINER:
            setContainer((CStructured) null);
            return;
        case CPackage.CSTRUCTURED__CONTAINS:
            getContains().clear();
            return;
        }
        eDynamicUnset(eFeature);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public boolean eIsSet(EStructuralFeature eFeature) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
        case CPackage.CSTRUCTURED__NAME:
            return isSetName();
        case CPackage.CSTRUCTURED__TD_LANG_TYPED_ELEMENT:
            return tdLangTypedElement != null && !tdLangTypedElement.isEmpty();
        case CPackage.CSTRUCTURED__TD_LANG_ELEMENT:
            return tdLangElement != null && !tdLangElement.isEmpty();
        case CPackage.CSTRUCTURED__CONTAINER:
            return getContainer() != null;
        case CPackage.CSTRUCTURED__CONTAINS:
            return contains != null && !contains.isEmpty();
        }
        return eDynamicIsSet(eFeature);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public int eBaseStructuralFeatureID(int derivedFeatureID, Class baseClass) {
        if (baseClass == CClassifier.class) {
            switch (derivedFeatureID) {
            default:
                return -1;
            }
        }
        if (baseClass == CStructureContents.class) {
            switch (derivedFeatureID) {
            case CPackage.CSTRUCTURED__CONTAINER:
                return CPackage.CSTRUCTURE_CONTENTS__CONTAINER;
            default:
                return -1;
            }
        }
        if (baseClass == CDerivableType.class) {
            switch (derivedFeatureID) {
            default:
                return -1;
            }
        }
        return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    public int eDerivedStructuralFeatureID(int baseFeatureID, Class baseClass) {
        if (baseClass == CClassifier.class) {
            switch (baseFeatureID) {
            default:
                return -1;
            }
        }
        if (baseClass == CStructureContents.class) {
            switch (baseFeatureID) {
            case CPackage.CSTRUCTURE_CONTENTS__CONTAINER:
                return CPackage.CSTRUCTURED__CONTAINER;
            default:
                return -1;
            }
        }
        if (baseClass == CDerivableType.class) {
            switch (baseFeatureID) {
            default:
                return -1;
            }
        }
        return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
    }

} //CStructuredImpl
