/**
 * <copyright>
 * </copyright>
 *
 * $Id: COBOLNumprocValue.java,v 1.2.4.1 2005/10/28 04:37:27 akkina Exp $
 */
package com.ibm.etools.cobol;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.AbstractEnumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>Numproc Value</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * <!-- begin-model-doc -->
 * Numproc(PDF) imposes stricter standards on decimal sign values.  
 * 
 * Values for Numproc are:
 * NOPFD, PFD, and MIG.
 * 
 * Use NUMPROC(NOPFD) if you want the compiler to perform invalid sign  processing.  This option is not as efficient as NUMPROC(PFD); object code size will be increased, and there may be an increase in run-time overhead  to validate all signed data. 
 * 
 * NUMPROC(NOPFD) and NUMPROC(MIG) conform to the COBOL 85 Standard. 
 * 
 * For more information on the Trunc attribute, please refer to "COBOL/VSE Programming Guide"
 * 
 * numproc is another compiler option.  The available options are PFD, NOPFD, and MIG.  More details about numproc can be found on:  http://w3.enterlib.ibm.com/cgi-bin/bookmgr/BOOKS/igyva002/3.2.2.29?ACTION=MATCHES&REQUEST=numproc&TYPE=FUZZY&searchTopic=TOPIC&searchText=TEXT&searchIndex=INDEX&rank=RANK&ScrollTOP=FIRSTHIT#FIRSTHIT
 * <!-- end-model-doc -->
 * @see com.ibm.etools.cobol.COBOLPackage#getCOBOLNumprocValue()
 * @model
 * @generated
 */
public final class COBOLNumprocValue extends AbstractEnumerator {
	/**
	 * The '<em><b>NOPFD</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #NOPFD_LITERAL
	 * @model 
	 * @generated
	 * @ordered
	 */
	public static final int NOPFD = 0;

	/**
	 * The '<em><b>PFD</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #PFD_LITERAL
	 * @model 
	 * @generated
	 * @ordered
	 */
	public static final int PFD = 1;

	/**
	 * The '<em><b>MIG</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #MIG_LITERAL
	 * @model 
	 * @generated
	 * @ordered
	 */
	public static final int MIG = 2;

	/**
	 * The '<em><b>NOPFD</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>NOPFD</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #NOPFD
	 * @generated
	 * @ordered
	 */
	public static final COBOLNumprocValue NOPFD_LITERAL = new COBOLNumprocValue(NOPFD, "NOPFD");

	/**
	 * The '<em><b>PFD</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>PFD</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #PFD
	 * @generated
	 * @ordered
	 */
	public static final COBOLNumprocValue PFD_LITERAL = new COBOLNumprocValue(PFD, "PFD");

	/**
	 * The '<em><b>MIG</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>MIG</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #MIG
	 * @generated
	 * @ordered
	 */
	public static final COBOLNumprocValue MIG_LITERAL = new COBOLNumprocValue(MIG, "MIG");

	/**
	 * An array of all the '<em><b>Numproc Value</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final COBOLNumprocValue[] VALUES_ARRAY =
		new COBOLNumprocValue[] {
			NOPFD_LITERAL,
			PFD_LITERAL,
			MIG_LITERAL,
		};

	/**
	 * A public read-only list of all the '<em><b>Numproc Value</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final List VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>Numproc Value</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static COBOLNumprocValue get(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			COBOLNumprocValue result = VALUES_ARRAY[i];
			if (result.toString().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Numproc Value</b></em>' literal with the specified value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static COBOLNumprocValue get(int value) {
		switch (value) {
			case NOPFD: return NOPFD_LITERAL;
			case PFD: return PFD_LITERAL;
			case MIG: return MIG_LITERAL;
		}
		return null;	
	}

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private COBOLNumprocValue(int value, String name) {
		super(value, name);
	}

} //COBOLNumprocValue
